<script setup lang="ts" generic="T extends GeolocalisableItem & ListableItem">
    import { useDisplay } from 'vuetify/lib/framework.mjs'
    import { GeolocalisableItem } from '@/elusServiceOffer/entities/GeolocalisableItem'
    import SItemMapViewer from './SItemMapViewer.vue'
    import SBottomSheet from '@/elusServiceOffer/components/layout/SBottomSheet.vue'
    import { ref, computed } from 'vue'
    import SListItem from '../items/SListItem.vue'
    import { ButtonAction } from '@/shared/button/entities/ButtonAction'
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import { pluralForm } from '@/shared/helpers/strings'
    import { ListableItem } from '@/shared/item/entities/ListableItem'
    import { ListableItemList } from '@/elusServiceOffer/entities/ListableItemList'

    interface Props {
        itemList: ListableItemList<T>
        noItemImage?: boolean
        primaryAction?: ButtonAction
        bookmarkable?: boolean
        bookmarks?: Array<string>
        currentTab: string
        openSelectedIntervention: (item: T) => void
        closeInterventionDetails: () => void
    }

    const props = withDefaults(defineProps<Props>(), {
        noItemImage: false,
        primaryAction: undefined,
        bookmarkable: false,
        bookmarks: () => [],
    })

    const emit = defineEmits(['update:bookmarks'])

    const bookmarksValue = computed({
        get() {
            return props.bookmarks
        },
        set(bookmarksValue) {
            emit('update:bookmarks', bookmarksValue)
        },
    })

    const expandPanel = ref<boolean>(false)

    const { mdAndUp } = useDisplay()

    const itemSelected = ref<GeolocalisableItem & ListableItem>()

    const tabs = [
        { id: 'filters', label: 'Filtres', icon: 'mdi-filter-outline' },
        { id: 'list', label: 'Liste', icon: 'mdi-list-box-outline' },
    ]
</script>

<template>
    <template v-if="mdAndUp">
        <div class="h-100 w-100 d-flex">
            <slot></slot>
            <div v-if="$vuetify.display.mdAndUp" id="items-list-desktop">
                <v-window v-model="$props.currentTab">
                    <v-window-item
                        v-for="(tab, index) in tabs"
                        :key="index"
                        :value="tab.id"
                    >
                        <template v-if="tab.id === 'list'">
                            <div>
                                <slot name="listHeader"></slot>
                                <v-list>
                                    <v-divider></v-divider>
                                    <template
                                        v-for="item in itemList.items"
                                        :key="item.getItemId()"
                                    >
                                        <s-list-item
                                            v-model:bookmarks="bookmarksValue"
                                            v-model:item-selected="itemSelected"
                                            :item="item"
                                            :to="item.getItemRoute()"
                                            :bookmarkable="bookmarkable"
                                            @click="
                                                $props.openSelectedIntervention(
                                                    item
                                                )
                                            "
                                        />
                                        <v-divider></v-divider>
                                    </template>
                                </v-list>
                            </div>
                        </template>
                        <template v-else-if="tab.id === 'filters'">
                            <slot name="filters"></slot>
                        </template>
                    </v-window-item>
                </v-window>
            </div>
            <div style="flex-grow: 1">
                <s-item-map-viewer
                    id="items-map-desktop"
                    v-model:item-selected="itemSelected"
                    :items="itemList.items"
                    style="width: 100%"
                />
            </div>
            <s-action-button
                v-if="primaryAction"
                :icon="primaryAction.icon"
                :label="primaryAction.label"
                :to="primaryAction.route"
                data-cy="primary-action-button"
                display="floating-absolute"
                position="right"
            >
            </s-action-button>
        </div>
    </template>
    <template v-else>
        <v-navigation-drawer
            v-model="expandPanel"
            location="left"
            data-cy="filter-panel"
        >
            <slot name="filterPanel"></slot>
        </v-navigation-drawer>
        <s-item-map-viewer
            id="items-map-mobile"
            v-model:item-selected="itemSelected"
            :items="itemList.items"
        />
        <s-bottom-sheet>
            <template #fab>
                <s-action-button
                    v-if="primaryAction"
                    :icon="primaryAction.icon"
                    :label="primaryAction.label"
                    :to="primaryAction.route"
                    data-cy="primary-action-button"
                >
                </s-action-button>
            </template>
            <template #header>
                <slot name="listHeader">
                    <h2 class="ml-2" data-cy="nb-items">
                        {{ itemList.items.length }}
                        {{ pluralForm('équipement', itemList.items.length) }}
                    </h2>
                </slot>
            </template>
            <div class="list-container">
                <v-list>
                    <v-divider></v-divider>
                    <template
                        v-for="item in itemList.items"
                        :key="item.getItemId()"
                    >
                        <s-list-item
                            v-model:bookmarks="bookmarksValue"
                            v-model:item-selected="itemSelected"
                            :item="item"
                            :to="item.getItemRoute()"
                            :bookmarkable="bookmarkable"
                            @click="$props.openSelectedIntervention(item)"
                        />
                        <v-divider></v-divider>
                    </template>
                </v-list>
            </div>
        </s-bottom-sheet>
    </template>
</template>

<style scoped lang="scss">
    /* desktop */
    #items-list-desktop {
        background-color: #f9fbfd;
        max-width: 500px;
        width: 100%;
        z-index: 2;
        overflow-y: auto;
        border-right: 1px solid #b8b9ba;
    }
    #items-map-desktop {
        width: 100%;
        height: 100%;
        z-index: 1;
    }
    /* mobile */
    #items-map-mobile {
        position: fixed;
        top: 0;
        bottom: 0;
        left: 0;
        right: 0;
        z-index: 1;
    }
</style>
